use Config;
use File::Basename qw(basename dirname);
chdir(dirname($0));

$perl = shift(@ARGV);

$use = "use lib qw(\n\t" . join("\n\t", @ARGV) . ");\n";

($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($Config{'osname'} eq 'VMS' or
	    $Config{'osname'} eq 'OS2');  # "case-forgiving"
open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
#!$perl -w

#
# Warning: File automatically generated. Any changes made here
# will be lost.
#

$use

!GROK!THIS!
print OUT <<'!NO!SUBS!';

=head1 NAME

delete-asset

=head1 SYNOPSIS

delete-asset asset_url

=head1 DESCRIPTION


=cut

use strict;

use Getopt::Long;

use MTk;

eval {
    &main;
};

if ($@)
{
    print "delete-asset failed:\n\t$@\n";
    exit(1);
}


exit(0);

sub main
{
    my($asset_url, $db, $repos_name);
    my($debug, $opt_rc);

    $opt_rc = &GetOptions("d" => \$debug);

    if ($opt_rc == 0)
    {
	&usage;
    }

    if (@ARGV == 0)
    {
	&usage;
    }

    $repos_name = shift(@ARGV);

    if (@ARGV != 1)
    {
	&usage;
    }

    $asset_url = shift(@ARGV);

    $db = $MTk::DBClass->new();
    $db or die "Cannot connect to database\n";
    
    $db->open();

    &validate_repository($db, $repos_name);

    eval {
	&delete_asset($db, $repos_name, $asset_url);
    };
    if ($@)
    {
	print "delete-asset $asset_url failed: $@";
    }
    #
    # This is needed to avoid a warning about invalidated cursors with dbi.
    # I suspect a bug somewhere in perl itself...
    
    1;
}

sub usage
{
    die "Usage: $0 repository assets\n";
}

#
# Make sure that this is a valid repository.
#

sub validate_repository
{
    my($db, $repos_name) = @_;
    my($q, $official_name);

    $q = $db->query("select official_name from Repository where name = '$repos_name'");
    $q or die "Repository $repos_name not found\n";

    $official_name = $q->item(0, 0);
    print "Adding to repository $official_name\n";
}


#
# Remove this asset from the database.
# 

sub delete_asset
{
    my($db, $repos_name, $asset_url) = @_;
    my($asset, $rc);
    my($q);

    $asset = MTk::DBTable::Asset->new($asset_url, $db);
    
    #
    # First see if it's already there
    #

    $rc = $asset->fetch();

    if (!$rc)
    {
	die "Asset $asset_url not present\n";
    }
    print "deleting $asset_url\n";

    $db->query("delete from Asset where id = '$asset_url'");
    $db->query("delete from Tag where asset_id = '$asset_url'");
}
!NO!SUBS!
    
